#include "mbed.h"
#include <cstdio>

#define WAIT_TIME_MS 500 

UnbufferedSerial my_pc(USBTX, USBRX);

PwmOut CCL_motor(D9);
PwmOut arm1(D10);
PwmOut arm2(D6);
PwmOut arm3(D7);

float speed, size_object, time_to_arm1, distance_camera_arm1, distance_camera_arm2, time_to_arm2, distance_camera_arm3, time_to_arm3;
char message[128], data;

void moveBelt(){
    CCL_motor.period_us(1750);
    CCL_motor.write(0.1); // Start moving the BELT
}

void Arm_Selection(void){
    my_pc.read(&data, 1);     // ReceiveData
    if(data == 'T'){ //Triangle or Pentagon
        thread_sleep_for(time_to_arm1*1000); // wait for the object to be close to the 1st arm
        arm1.pulsewidth_ms(2.42);// move arm forwards
        thread_sleep_for(3*1000); // wait 3 sec
        arm1.pulsewidth_ms(1); // move arm backwards
    } else if (data == 'S') { //Square or Hexagon
        thread_sleep_for(time_to_arm2*1000); // wait for the object to be close to the 2nd arm
        arm2.pulsewidth_ms(2.42); // move arm forwards
        thread_sleep_for(3*1000); // wait 3 sec
        arm2.pulsewidth_ms(1); // move arm backwards
    } else if (data == 'H') { //Circle
        thread_sleep_for(time_to_arm3*1000); // wait for the object to be close to the 2nd arm
        arm3.pulsewidth_ms(2.42); // move arm forwards
        thread_sleep_for(3*1000); // wait 3 sec
        arm3.pulsewidth_ms(1); // move arm backwards
    }  // else its the circle      
    my_pc.write(&data, 1);    // echo of the byte received
}

int main() {
    my_pc.baud(115200);

    speed = 3.1835;  // motor velocity in cm/s
    size_object = 1.4; // object size in cm

    // All distances take the camera as reference and are in centimeters
    distance_camera_arm1 = 6.5; // in cm
    distance_camera_arm2 = 22.3; // in cm
    distance_camera_arm3 = 29.5; // in cm

    //time_to_camera = distance_to_camera / speed; // time for the object to go from the sensor to the camera in sec
    time_to_arm1 = distance_camera_arm1 / speed; // time for the object to go from the camera to the first arm in sec
    time_to_arm2 = distance_camera_arm2 / speed; // time for the object to go from the camera to the second arm in sec
    time_to_arm3 = distance_camera_arm3 / speed; // time for the object to go from the camera to the third arm in sec

    moveBelt();

    arm1.period_ms(20);
    arm2.period_ms(20);
    arm3.period_ms(20);
    arm1.pulsewidth_ms(1);
    arm2.pulsewidth_ms(1);
    arm3.pulsewidth_ms(1);

    while(1){
        Arm_Selection();
        thread_sleep_for(500);   
    }
}